<?php
/************************************************************************/
/* Openads 2.0                                                          */
/* ===========                                                          */
/*                                                                      */
/* Copyright (c) 2000-2007 by the Openads developers                    */
/* For more information visit: http://www.openads.org                   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

function phpAds_getUserAgent() {
	if(preg_match('#MSIE ([0-9].[0-9]{1,2})(.*Opera ([0-9].[0-9]{1,2}))?#', $_SERVER['HTTP_USER_AGENT'], $log_version)) {
		if(isset($log_version[3])) {
			$ver = $log_version[3];
			$agent = 'Opera';
		} else {
			$ver = $log_version[1];
			$agent = 'IE';
		}
	} elseif (preg_match('#Opera[/ ]([0-9].[0-9]{1,2})#', $_SERVER['HTTP_USER_AGENT'], $log_version)) {
		$ver = $log_version[1];
		$agent = 'Opera';
	} elseif (strstr($_SERVER['HTTP_USER_AGENT'], 'Safari') && preg_match('#Safari/([0-9]{1,3})#', $_SERVER['HTTP_USER_AGENT'], $log_version)) {
		$ver = $log_version[1];
		$agent = 'Safari';
	} elseif (strstr($_SERVER['HTTP_USER_AGENT'], 'Konqueror') && preg_match('#Konqueror/([0-9])#', $_SERVER['HTTP_USER_AGENT'], $log_version)) {
		$ver = $log_version[1];
		$agent = 'Konqueror';
	} elseif (preg_match('#Mozilla/([0-9].[0-9]{1,2})#', $_SERVER['HTTP_USER_AGENT'], $log_version)) {
		$ver = $log_version[1];
		$agent = 'Mozilla';
	} else {
		$ver = 0;
		$agent = 'Other';
	}
	
	if (strstr($_SERVER['HTTP_USER_AGENT'], 'Win')) {
		$platform = 'Win';
	} elseif (strstr($_SERVER['HTTP_USER_AGENT'], 'Mac')) {
		$platform = 'Mac';
	} elseif (strstr($_SERVER['HTTP_USER_AGENT'], 'Linux')) {
		$platform = 'Linux';
	} elseif (strstr($_SERVER['HTTP_USER_AGENT'], 'Unix')) {
		$platform = 'Unix';
	} else {
		$platform = 'Other';
	}
	
	return array(
		'agent' => $agent,
		'version' => $ver,
		'platform' => $platform
	);
}

?>